local statics = require("statics")
local rectangle = require("Models/rectangle")
local custommethods = require("Models/custommethods")

local sprite = {}
sprite.__index = sprite

sprite.properties = 
{
    x = 0,
    y = 0,
    width = 0,
    height = 0,
    scale = statics.scale,
    animated = false,
    animations = {},
    vel = 
    {
        x = 0,
        y = 0,
    },
    rect = function(self)
        return 
        {
            x = self.x + self.vel.x,
            y = self.y + self.vel.y,
            width = self.width * statics.scale,
            height = self.height * statics.scale,
        }
    end,
}

function sprite:new()
    local self = setmetatable(sprite.properties, sprite)
    return self
end

function sprite:update(dt)
    self.currentanim:update(dt)

    self.x = self.x + self.vel.x
    self.y = self.y + self.vel.y

    self.vel.x = 0
    self.vel.y = 0
end

function sprite:draw()
    if self.animated then
        love.graphics.draw(self.texture, self.currentanim:getquad(), self.x, self.y, 0, self.scale, self.scale, 0, 0)
    else
        love.graphics.draw(self.texture, self.x, self.y, 0, self.scale, self.scale, 0, 0)
    end
end

return sprite